package com.csm_dev.csmarket.csm.adapter;

import android.app.Activity;
import android.content.Intent;
import android.os.Bundle;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.ImageView;
import android.widget.RelativeLayout;
import android.widget.TextView;
import android.widget.Toast;

import androidx.annotation.NonNull;
import androidx.fragment.app.FragmentActivity;
import androidx.fragment.app.FragmentManager;
import androidx.fragment.app.FragmentTransaction;
import androidx.recyclerview.widget.RecyclerView;

import com.csm_dev.csmarket.R;
import com.csm_dev.csmarket.csm.DialogFrag.DialogNoti;
import com.csm_dev.csmarket.csm.DialogFrag.Dialog_Reward;
import com.csm_dev.csmarket.csm.activity.VisitHandler;
import com.csm_dev.csmarket.csm.model.ModelNoti;
import com.csm_dev.csmarket.csm.model.VisitModel;

import java.util.List;


public class AdapterNoti extends RecyclerView.Adapter<AdapterNoti.MyViewHolder> {
    public AdapterNoti(List<ModelNoti> mList, Activity activity) {
        this.mList = mList;
        this.activity = activity;
    }

    List<ModelNoti> mList;
    Activity activity;

    @NonNull
    @Override
    public MyViewHolder onCreateViewHolder(@NonNull ViewGroup parent, int viewType) {
        LayoutInflater layoutInflater = LayoutInflater.from(parent.getContext());
        View view = layoutInflater.inflate(R.layout.item_csm_noti, parent, false);
        return new MyViewHolder(view);
    }

    @Override
    public void onBindViewHolder(@NonNull MyViewHolder holder, int position) {
        ModelNoti model = mList.get(position);
        holder.title.setText(model.getTitle());
        holder.sub.setText(model.getSub());
        holder.date.setText(model.getDate());

        holder.click.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                FragmentManager fragmentManager = ((FragmentActivity)activity).getSupportFragmentManager();
                DialogNoti newFragment = new DialogNoti();
                Bundle args = new Bundle();
                args.putString("title", model.getTitle());
                args.putString("sub", model.getSub());

                newFragment.setArguments(args);
                FragmentTransaction transaction = fragmentManager.beginTransaction();
                transaction.setTransition(FragmentTransaction.TRANSIT_FRAGMENT_OPEN);
                transaction.add(android.R.id.content, newFragment).addToBackStack(null).commit();

            }
        });


    }

    @Override
    public int getItemCount() {
        return mList.size();
    }

    public class MyViewHolder extends RecyclerView.ViewHolder {
        TextView title,sub,date;
        RelativeLayout click;

        public MyViewHolder(@NonNull View itemView) {
            super(itemView);
            title = itemView.findViewById(R.id.title);
            click = itemView.findViewById(R.id.click);
            sub = itemView.findViewById(R.id.sub);
            date = itemView.findViewById(R.id.date);

        }
    }
}